<?php
/**************************************************************************************************
**																								 **
**																								 **
**     La presente clase ha sido creada con la finalidad de permitir la conversin de una        **
**     o ms colecciones de imgenes JPG y sus correspondientes thumbnails a cadenas binarias,   **
**     para su almacenamiento en BBDD. Para su correcto uso, lee la documentacin adjunta.       **
**																								 **
**     Esta clase ha sido creada por www.sunflower.es, la Comunidad Virtual para la Difusin     **
**     de Software Libre. No est sujeta a ningn tipo de derechos de autor, copyright, ni       **
**     otras zarandajas. As pues, puedes usarla libremente, incorporarla en tus scripts,        **
**     distribuirla, modificarla, o lo que se te ocurra.                                         **
**																								 **
**																								 **
**************************************************************************************************/
class image2mysql {
/* Se declaran las propiedades de la clase. Las que aparecen como "public" son para ser manejadas
desde el exterior (en esta clase en concreto, deben ser asignadas a travs de una instancia,
inmediatamente despus de crearla). La variables declaradas como "private" no deben ser manipuladas
desde una instancia, sino que las usa la clase para su trabajo.*/

/* El primer grupo de variables se refiere a las ubicaciones de los ficheros que contienen
las imgenes que vamos a binarizar para grabar en la BBDD.*/
	public $rutaDeOriginales; //Ruta en la que estn las imgenes originales.
	public $rutaDeMiniaturas; //Ruta en la que estn las imgenes thumbnails.
	private $longRutaDeOriginales; //Longitud, en caracteres, de la ruta de las imgenes originales.
	private $longRutaDeMiniaturas; //Longitud, en caracteres, de la ruta de las imgenes originales.

/* El segundo grupo de variables se refiere a la BBDD. */
	public $conexion; // Recurso de la conexin con la BBDD. Lo normal es que esta conexin est definida en el script que usa la clase, fuera de esta.
	public $nombreDeTabla; // Nombre de la tabla en la que se almacenan las imgenes.
	public $campoDeNombre; // Nombre del campo que almacena el nombre de la imagen.
	public $campoDeFotoOriginal; // Nombre del campo que almacenar la foto binarizada.
	public $campoDeAnchoOriginal; // Nombre del campo que almacenar la anchura de la foto original.
	public $campoDeAltoOriginal; // Nombre del campo que almacenar la altura de la foto original.
	public $campoDeMiniatura; // Nombre del campo que almacena la thumbnail binarizada.
	public $campoDeAnchoMini; // Nombre del campo que almacena la anchura de la thumbnail.
	public $campoDeAltoMini; // Nombre del campo que almacena la altura de la thumbnail.
	public $campoDeCategoria = ""; // Nombre del campo que almacena el cdigo de lacategora de la imagen.
	public $valorDeCategoria; // Cdigo de categora que queremos dar a las imgenes.
	public $campoDeTipo; // Nombre del campo en el que se almacena el tipo MIME de la imagen.

/* El tercer grupo son las variables correspondientes a datos de las imgenes que se binaricen. */
	private $datosImagenOriginal = array(); // Datos de tamao de la imagen original.
	private $anchuraOriginal; // Anchura de la imagen original.
	private $alturaOriginal; // Altura de la imagen original.
	private $datosImagenMini = array(); // Datos de tamao de la thumbnail.
	private $anchuraMini; // Anchura de la thumbnail.
	private $alturaMini; // Altura de la thumbnail.
	private $valorDeTipo; // Esta variable recibir el tipo MIME de la imagen.
/* Todas las dimensiones sern en pxeles. */

/* El siguiente mtodo (el nico definido en la clase) se encarga de buscar las imgenes de tipo JPG
en las rutas especificadas, converstirlas a cadenas binarias, y grabarlas, junto con sus datos
asociados (nombre del fichero, anchura, altura y tipo mime) en los campos indicados de la tabla
especificada. Se ha preparado todo en torno a imgenes de tipo JPG por ser las ms extendidas,
con diferencia, en la web. No obstante, es fcil modificar la clase para operar con imgenes gif o png.*/
	function binarizar(){
		$longRutaDeOriginales = strlen($this->rutaDeOriginales);
		$longRutaDeMiniaturas = strlen($this->rutaDeMiniaturas);
/* Se buscan todos los archivos que haya en la ruta indicada para las imgenes originales. Los nombres de
dichos archivos deben coincidir con los de las thumbnails, ya que el nombre de cada archivo se usa para
buscar, ms adelante, la thumbnail en la ruta de estas.*/
		foreach (glob($this->rutaDeOriginales."*") as $fotoOriginal){
/* Para cada archivo encontrado en la ruta de originales se determina su nombre, prescindiendo
de la propia ruta. */
			$nombreDelFichero = substr($fotoOriginal, $longRutaDeOriginales);
/* Too el resto del proceso est supeditado a que el archivo encontrado sea una imagen JPG. Esto se
determina por la extension de dicho archivo, por convencionalismo. */
			if (strtolower(substr($fotoOriginal, strlen($fotoOriginal)-4))==".jpg"){
/* Se obtiene la anchura, altura y tipo mime de la imagen original. */
				$datosImagenOriginal = getimagesize($fotoOriginal);
				$anchuraOriginal = $datosImagenOriginal[0];
				$alturaOriginal = $datosImagenOriginal[1];
				$valorDeTipo = $datosImagenOriginal["mime"];
/* Se abre la imagen como un fichero, para lectura binaria, a fin de obtener la secuencia que
grabaremos en la BBDD. */
				$manejadorDeFoto = fopen($fotoOriginal, "rb");
				$fotoBinarizada = fread($manejadorDeFoto, filesize($fotoOriginal));
				$fotoBinarizada = addslashes($fotoBinarizada);
				fclose($manejadorDeFoto);
				clearstatcache(); // Limpiamos la cache de archivo leido.

/* El siguiente bloque de trabajo se efecta sobre la thumnail. Empezamos determinando su ubicacin
en base a la ruta especificada al crear el objeto y el nombre del archivo de la imagen original. */
				$miniatura = $this->rutaDeMiniaturas.$nombreDelFichero;
/* Se obtiene la anchura, altura y tipo mime de la thumbnail. */
				$datosImagenMini = getimagesize($miniatura);
				$anchuraMini = $datosImagenMini[0];
				$alturaMini = $datosImagenMini[1];
/* Se abre la thumbnail como un fichero, para lectura binaria, a fin de obtener la secuencia que
grabaremos en la BBDD. */
				$manejadorDeMiniatura = fopen($miniatura, "rb");
				$miniBinarizada = fread($manejadorDeMiniatura, filesize($miniatura));
				$miniBinarizada = addslashes($miniBinarizada);
				fclose($manejadorDeMiniatura);
				clearstatcache(); // Limpiamos la cache de archivo leido.

/* En base a todos los datos obtenidos y procesados se genera la consulta SQL para grabar la imgen
en la correspondiente tabla. */
				if ($this->campoDeCategoria == ""){
					$consulta = "INSERT INTO ".$this->nombreDeTabla."(".$this->campoDeNombre.", ";
					$consulta .= $this->campoDeFotoOriginal.", ".$this->campoDeAnchoOriginal.", ";
					$consulta .= $this->campoDeAltoOriginal.", ".$this->campoDeMiniatura.", ";
					$consulta .= $this->campoDeAnchoMini.", ".$this->campoDeAltoMini.", ";
					$consulta .= ", ".$this->campoDeTipo.") VALUES ('";
					$consulta .= $nombreDelFichero."', '".$fotoBinarizada."', '".$anchuraOriginal."', '";
					$consulta .= $alturaOriginal."', '".$miniBinarizada."', '".$anchuraMini."', '";
					$consulta .= $alturaMini."', '".$valorDeTipo."');";
				} else {
					$consulta = "INSERT INTO ".$this->nombreDeTabla."(".$this->campoDeNombre.", ";
					$consulta .= $this->campoDeFotoOriginal.", ".$this->campoDeAnchoOriginal.", ";
					$consulta .= $this->campoDeAltoOriginal.", ".$this->campoDeMiniatura.", ";
					$consulta .= $this->campoDeAnchoMini.", ".$this->campoDeAltoMini.", ";
					$consulta .= $this->campoDeCategoria.", ".$this->campoDeTipo.") VALUES ('";
					$consulta .= $nombreDelFichero."', '".$fotoBinarizada."', '".$anchuraOriginal."', '";
					$consulta .= $alturaOriginal."', '".$miniBinarizada."', '".$anchuraMini."', '";
					$consulta .= $alturaMini."', '".$this->valorDeCategoria."', '".$valorDeTipo."');";
				}
/* Se graba la imagen usando el recurso de conexin obtenido desde el exterior. */
				$hacerConsulta = mysql_query ($consulta, $this->conexion);
			}
		}
	}
}
?>