<?php
//=============================================================================================================================
/* Las clases para los enlaces proceden de un archivo css que es invocado desde el script principal (paginacion.php). */
/* La siguiente funcin muestra los enlaces bsicos de navegacin (primera, anterior, siguiente y ltima),
cuando es invocada desde el cuerpo principal del script. */
	function generarTablaDeEnlacesBasicos($paginaActual, $numeroDePaginas){
		echo "<table width='500' border='0' cellspacing='0' cellpadding='0' align='center'>\n\t<tr>\n";
		if ($paginaActual == 1){
//Mostrar como enlaces anulados, o en gris, o lo que se ponga como diseo.
			echo "\t\t<td width='125' align='center' valign='middle'><span class=\"enlaces_paginacion_inactivos\">PRIMERA</span></td>\n"; 
			echo "\t\t<td width='125' align='center' valign='middle'><span class=\"enlaces_paginacion_inactivos\">ANTERIOR</span></td>\n";
		} else {
//Mostrar como enlaces activos.
			echo "\t\t<td width='125' align='center' valign='middle'><span class=\"enlaces_paginacion_activados\"><a href=\"javascript:mostrarPagina('1');\">PRIMERA</a></span></td>\n";
			echo "\t\t<td width='125' align='center' valign='middle'><span class=\"enlaces_paginacion_activados\"><a href=\"javascript:mostrarPagina('".($paginaActual - 1)."');\">ANTERIOR</a></span></td>\n";
		}
		if ($paginaActual == $numeroDePaginas){
//Mostrar como enlaces anulados, o en gris, o lo que se ponga como diseo.
			echo "\t\t<td width='125' align='center' valign='middle'><span class=\"enlaces_paginacion_inactivos\">SIGUIENTE</span></td>\n";
			echo "\t\t<td width='125' align='center' valign='middle'><span class=\"enlaces_paginacion_inactivos\">&Uacute;LTIMA</span></td>\n";
		} else {
//Mostrar como enlaces activos.
			echo "\t\t<td width='125' align='center' valign='middle'><span class=\"enlaces_paginacion_activados\"><a href=\"javascript:mostrarPagina('".($paginaActual + 1)."');\">SIGUIENTE</a></span></td>\n";
			echo "\t\t<td width='125' align='center' valign='middle'><span class=\"enlaces_paginacion_activados\"><a href=\"javascript:mostrarPagina('".$numeroDePaginas."');\">&Uacute;LTIMA</a></span></td>\n";
		}
		echo "\t</tr>\n</table>\n";
	}

//=============================================================================================================================

/* La siguiente funcin se usa para generar los enlaces numerados a las distintas pginas de informacin. */
	function generarTablaDeEnlacesNumerados($enlacesPorNumeroDePagina, $numeroDePaginas, $paginaActual){
/* Lo primero es empezar determinando si el valor de $enlacesPorNumeroDePagina es cero. Este valor se establece al principio del script.
Si es 0, debemos construir una tabla HTML con enlaces a todas las pginas posibles de informacin de la BBDD, excepto, por supuesto,
la pgina en curso. */
		if ($enlacesPorNumeroDePagina == 0){
			$totalDeFilas = ceil($numeroDePaginas/10);
			echo "<table width='500' border='0' cellspacing='0' cellpadding='0' align='center'>\n";
			for ($contadorDeFilas = 0; $contadorDeFilas < $totalDeFilas; $contadorDeFilas++){
				echo "\t<tr>\n";
				$cuentaDeEnlaces = 0;
				for ($numeroMostrado = (($contadorDeFilas*10)+1); $numeroMostrado <= (($contadorDeFilas*10)+10); $numeroMostrado ++){
					if ($numeroMostrado>$numeroDePaginas) break;
					if ($numeroMostrado != $paginaActual){
						echo "\t\t<td width='50' align='center'><span class=\"enlaces_paginacion_activados\"><a href=\"javascript:mostrarPagina('".$numeroMostrado."');\">";
						echo $numeroMostrado."</a></span></td>\n"; //Enlace a otra pgina.
					} else {
						echo "\t\t<td width='50' align='center'><span class=\"enlaces_paginacion_inactivos\">".$numeroMostrado."</span></td>\n"; //Nmero sin enlace.
					}
					$cuentaDeEnlaces++;
				}
				while ($cuentaDeEnlaces < 10){
					echo "\t\t<td width='50' align='center'>&nbsp;</td>\n";
					$cuentaDeEnlaces++;
				}
				echo "\t</tr>\n";
			}
			echo "</table>\n";
		} else {
/* Si el valor de $enlacesPorNumeroDePagina no es cero, debemos construir una tabla con el nmero de enlaces especificado en esta variable.
en ese caso, debemos determinar el lmite inferior y el superior, de modo que el nmero de la pgina actual (sin enlace) est en medio
si es posible.*/
			if ($paginaActual <= ceil($enlacesPorNumeroDePagina/2)){
				$limiteInferior = 1;
			} else {
				$limiteInferior = ($paginaActual - floor($enlacesPorNumeroDePagina/2));
			}
			if ($limiteInferior<1) $limiteInferior = 1; //El primer enlace no debe ser menor que uno, es decir, apuntando a la primera pgina, como muy inferior.
			if (($paginaActual + floor($enlacesPorNumeroDePagina/2)) >= $numeroDePaginas){
				$limiteSuperior = $numeroDePaginas;
			} else {
				$limiteSuperior = ($paginaActual + floor($enlacesPorNumeroDePagina/2));
			}
			echo "<table border='0' cellspacing='0' cellpadding='0' align='center'>\n\t<tr>\n";
			$cuentaDeEnlaces = 0;
			for ($numeroMostrado = $limiteInferior; $numeroMostrado<=$limiteSuperior; $numeroMostrado++){
				if ($numeroMostrado != $paginaActual){
					echo "\t\t<td width='50' align='center'><span class=\"enlaces_paginacion_activados\"><a href=\"javascript:mostrarPagina('".$numeroMostrado."');\">";
					echo $numeroMostrado."</a></span></td>\n"; //Enlace a otra pgina
				} else {
					echo "\t\t<td width='50' align='center'><span class=\"enlaces_paginacion_inactivos\">".$numeroMostrado."</span></td>\n"; //Nmero sin enlace.
				}
				$cuentaDeEnlaces++;
			}
			echo "\t</tr>\n</table>\n";
		}
	}
/* Aqu acaba la funcin que genera los enlaces numerados a las distintas pginas de informacin. */

?>